
function value=conn_merge(value0,value)
DEBUG=0;
global CONN_x;
if ischar(value0),
    filenames=value0;
    value0=CONN_x.Setup.nsubjects; 
    idx0=1:value0;
    value=value0;
    other{1}.CONN_x=CONN_x;
    otheridx1=ones(1,value0);
    otheridx2=1:value0;
    otheridx3=ones(1,value0);
    for n1=1:size(filenames,1),
        other{1+n1}=load(deblank(filenames(n1,:)),'-mat');
        other{1+n1}.CONN_x.filename=deblank(filenames(n1,:));
        other{1+n1}.CONN_x=conn_updatefolders(other{1+n1}.CONN_x);
        nsubs=other{1+n1}.CONN_x.Setup.nsubjects;
        value=value+nsubs;
        otheridx1=[otheridx1,1+n1+zeros(1,nsubs)];  % index to conn project
        otheridx2=[otheridx2,1:nsubs];              % index to subject within conn project
        otheridx3=[otheridx3,ones(1,nsubs)];         % 1/0 indicating whether subject data exists
    end
    idx1=1:value;
else,
    if nargin<1||isempty(value0), value0=CONN_x.Setup.nsubjects; end
    idx0=1:value0;
    if value>=value0, idx1=1:value;
    else,
        names=[repmat('Subject ',[value0,1]),num2str((1:value0)')];
        Ransw=zeros(1,value0-value+1);
        while length(Ransw)>0&&length(Ransw)~=value0-value,
            Ransw=listdlg('name',['Removing subjects!'],'PromptString',['Select ',num2str(value0-value),' subjects to remove'],'ListString',names,'SelectionMode','multiple');
        end
        if ~isempty(Ransw), idx1=setdiff(1:value0,Ransw); else, value=value0; return; end
        Ransw=questdlg('This will permanently remove any connectivity data for the selected subjects. Are you sure you want to continue?','','Yes','No','No');
        if ~strcmp(Ransw,'Yes'), value=value0; return; end
    end
    other{1}.CONN_x=CONN_x;
    otheridx1=ones(1,value);
    otheridx2=min(value0,idx1);
    otheridx3=idx1<=value0;
end
if length(other)>1, % check same definitions across projects
    TXT={};
    for n1=2:length(other),
        if other{1}.CONN_x.Setup.RT~=other{n1}.CONN_x.Setup.RT, TXT{end+1}=['Mismatched TR with project ',other{n1}.CONN_x.filename]; end
        if length(other{1}.CONN_x.Setup.rois.names)~=length(other{n1}.CONN_x.Setup.rois.names) || any(any(size(strvcat(other{1}.CONN_x.Setup.rois.names{:}))~=size(strvcat(other{n1}.CONN_x.Setup.rois.names{:})))) || any(any((strvcat(other{1}.CONN_x.Setup.rois.names{:}))~=(strvcat(other{n1}.CONN_x.Setup.rois.names{:})))), TXT{end+1}=['Mismatched ROI names with project ',other{n1}.CONN_x.filename]; end
        if length(other{1}.CONN_x.Setup.conditions.names)~=length(other{n1}.CONN_x.Setup.conditions.names) || any(any(size(strvcat(other{1}.CONN_x.Setup.conditions.names{:}))~=size(strvcat(other{n1}.CONN_x.Setup.conditions.names{:})))) || any(any((strvcat(other{1}.CONN_x.Setup.conditions.names{:}))~=(strvcat(other{n1}.CONN_x.Setup.conditions.names{:})))), TXT{end+1}=['Mismatched condition names with project ',other{n1}.CONN_x.filename]; end
        if length(other{1}.CONN_x.Setup.l1covariates.names)~=length(other{n1}.CONN_x.Setup.l1covariates.names) || any(any(size(strvcat(other{1}.CONN_x.Setup.l1covariates.names{:}))~=size(strvcat(other{n1}.CONN_x.Setup.l1covariates.names{:})))) || any(any((strvcat(other{1}.CONN_x.Setup.l1covariates.names{:}))~=(strvcat(other{n1}.CONN_x.Setup.l1covariates.names{:})))), TXT{end+1}=['Mismatched first-level covariate names with project ',other{n1}.CONN_x.filename]; end
        if length(other{1}.CONN_x.Setup.l2covariates.names)~=length(other{n1}.CONN_x.Setup.l2covariates.names) || any(any(size(strvcat(other{1}.CONN_x.Setup.l2covariates.names{:}))~=size(strvcat(other{n1}.CONN_x.Setup.l2covariates.names{:})))) || any(any((strvcat(other{1}.CONN_x.Setup.l2covariates.names{:}))~=(strvcat(other{n1}.CONN_x.Setup.l2covariates.names{:})))), TXT{end+1}=['Mismatched second-level covariate names with project ',other{n1}.CONN_x.filename]; end
    end
    if ~isempty(TXT),
        disp(strvcat(TXT{:}));
        value=value0;
        return;
    end
end
if length(CONN_x.Setup.nsessions)==1&&CONN_x.Setup.nsubjects>1, CONN_x.Setup.nsessions=CONN_x.Setup.nsessions+zeros(1,CONN_x.Setup.nsubjects); end
for nsub=setdiff(idx1,idx0), % new subjects 
    CONN_x.Setup.functional{nsub}=other{otheridx1(nsub)}.CONN_x.Setup.functional{otheridx2(nsub)};
	CONN_x.Setup.structural{nsub}=other{otheridx1(nsub)}.CONN_x.Setup.structural{otheridx2(nsub)};
	CONN_x.Setup.spm{nsub}=other{otheridx1(nsub)}.CONN_x.Setup.spm{otheridx2(nsub)};
	CONN_x.Setup.rois.files{nsub}=other{otheridx1(nsub)}.CONN_x.Setup.rois.files{otheridx2(nsub)};
	CONN_x.Setup.conditions.values{nsub}=other{otheridx1(nsub)}.CONN_x.Setup.conditions.values{otheridx2(nsub)};
	CONN_x.Setup.l1covariates.files{nsub}=other{otheridx1(nsub)}.CONN_x.Setup.l1covariates.files{otheridx2(nsub)};
	CONN_x.Setup.l2covariates.values{nsub}=other{otheridx1(nsub)}.CONN_x.Setup.l2covariates.values{otheridx2(nsub)};
	CONN_x.Setup.nscans{nsub}=other{otheridx1(nsub)}.CONN_x.Setup.nscans{otheridx2(nsub)};
    CONN_x.Setup.nsessions(nsub)=other{otheridx1(nsub)}.CONN_x.Setup.nsessions(otheridx2(nsub));
end								
CONN_x.Setup.functional={CONN_x.Setup.functional{idx1}};
CONN_x.Setup.structural={CONN_x.Setup.structural{idx1}};
CONN_x.Setup.spm={CONN_x.Setup.spm{idx1}};
CONN_x.Setup.rois.files={CONN_x.Setup.rois.files{idx1}};
CONN_x.Setup.conditions.values={CONN_x.Setup.conditions.values{idx1}};
CONN_x.Setup.l1covariates.files={CONN_x.Setup.l1covariates.files{idx1}};
CONN_x.Setup.l2covariates.values={CONN_x.Setup.l2covariates.values{idx1}};
CONN_x.Setup.nscans={CONN_x.Setup.nscans{idx1}};
CONN_x.Setup.nsessions=CONN_x.Setup.nsessions(idx1);

% rename/copy analysis files
if (value<value0||any(otheridx3(setdiff(idx1,idx0)))) && ~isempty(CONN_x.filename),
    for nother=1:length(other),
        filepath=other{nother}.CONN_x.folders.data;
        filepathresults1=other{nother}.CONN_x.folders.preprocessing;
        filepathresults2=other{nother}.CONN_x.folders.firstlevel;
        filepathresults3={};for ianalysis=1:length(other{nother}.CONN_x.Analyses), filepathresults3{ianalysis}=fullfile(other{nother}.CONN_x.folders.firstlevel,other{nother}.CONN_x.Analyses(ianalysis).name); end
        filenameskey='Subject';
        filenamesall{nother}=[];
        filesubjsall{nother}=[];
        filepathall{nother}={filepath,filepathresults1,filepathresults3{:}};
        for n0=1:length(filepathall{nother}),
            files=dir(fullfile(filepathall{nother}{n0},['*',filenameskey,'*']));
            for n1=1:length(files),
                k=strfind(files(n1).name,filenameskey);
                if ~isempty(k),
                    k=k(1);
                    m=files(n1).name(k+length(filenameskey):end);
                    [nill,idx]=min((m>='0'&m<='9'));if ~nill,m=m(1:idx-1);end
                    if ~isempty(m)&&length(str2num(m))==1,
                        filesubjsall{nother}=cat(1,filesubjsall{nother},[str2num(m),k+length(filenameskey),length(m),n0]);
                        filenamesall{nother}=strvcat(filenamesall{nother},fullfile(filepathall{nother}{n0},files(n1).name));
                    end
                end
            end
        end
    end
    for nsub=1:max(value0,value),
        if nsub>length(idx1),% remove
            idx=find(filesubjsall{1}(:,1)==idx0(nsub));
            for n1=1:length(idx),
                if ispc, if ~DEBUG,[ok,nill]=system(['del ',deblank(filenamesall{1}(idx(n1),:))]);end
                    disp(['deleting ',filenamesall{1}(idx(n1),:)]);
                elseif isunix, if ~DEBUG,[ok,nill]=system(['rm ',deblank(filenamesall{1}(idx(n1),:))]);end
                    disp(['deleting ',filenamesall{1}(idx(n1),:)]); end
            end
        elseif nsub>length(idx0), % new subject
            if otheridx3(nsub),%CONN_x{nsub} <- other{otheridx1(nsub)}.CONN_x{otheridx2(nsub)};
                idx=find(filesubjsall{otheridx1(nsub)}(:,1)==otheridx2(nsub));
                for n1=1:length(idx),
                    [filepath,filename,fileext]=fileparts(deblank(filenamesall{otheridx1(nsub)}(idx(n1),:)));
                    newfilename=[filename(1:filesubjsall{otheridx1(nsub)}(idx(n1),2)-1),num2str(idx1(nsub),['%0',num2str(filesubjsall{otheridx1(nsub)}(idx(n1),3)),'d']),filename(filesubjsall{otheridx1(nsub)}(idx(n1),2)+filesubjsall{otheridx1(nsub)}(idx(n1),3):end)];
                    %filepath=filepathall{otheridx1(nsub)}{filesubjsall{otheridx1(nsub)}(idx(n1),4)};
                    newfilepath=filepathall{1}{filesubjsall{otheridx1(nsub)}(idx(n1),4)};
                    if ispc, if ~DEBUG,[ok,nill]=system(['copy ',fullfile(filepath,[filename,fileext]),' ',fullfile(newfilepath,[newfilename,fileext])]);end
                        disp(['copying ',fullfile(filepath,[filename,fileext]),' ',fullfile(newfilepath,[newfilename,fileext])]);
                    elseif isunix, if ~DEBUG,[ok,nill]=system(['cp ',fullfile(filepath,[filename,fileext]),' ',fullfile(newfilepath,[newfilename,fileext])]);end
                        disp(['copying ',fullfile(filepath,[filename,fileext]),' ',fullfile(newfilepath,[newfilename,fileext])]);
                    end
                end
            end
        elseif idx0(nsub)~=idx1(nsub), % subject renamed
            idx=find(filesubjsall{1}(:,1)==idx0(nsub));
            for n1=1:length(idx),
                [filepath,filename,fileext]=fileparts(deblank(filenamesall{1}(idx(n1),:)));
                newfilename=[filename(1:filesubjsall{1}(idx(n1),2)-1),num2str(idx1(nsub),['%0',num2str(filesubjsall{1}(idx(n1),3)),'d']),filename(filesubjsall{1}(idx(n1),2)+filesubjsall{1}(idx(n1),3):end)];
                tmp=strmatch(fullfile(filepath,[newfilename,fileext]),filenamesall{1},'exact');if isempty(tmp),newfilename=[filename(1:filesubjsall{1}(idx(n1),2)-1),num2str(idx1(nsub),['%',num2str(filesubjsall{1}(idx(n1),3)),'d']),filename(filesubjsall{1}(idx(n1),2)+filesubjsall{1}(idx(n1),3):end)];end;if isempty(strmatch(fullfile(filepath,[newfilename,fileext]),filenamesall{1},'exact')),disp('warning, non existing target file'); end
                if ispc, if ~DEBUG, [ok,nill]=system(['copy ',fullfile(filepath,[newfilename,fileext]),' ',fullfile(filepath,[filename,fileext])]);end
                    disp(['renaming ',fullfile(filepath,[newfilename,fileext]),' ',fullfile(filepath,[filename,fileext])]);
                elseif isunix, if ~DEBUG, [ok,nill]=system(['cp ',fullfile(filepath,[newfilename,fileext]),' ',fullfile(filepath,[filename,fileext])]);end
                    disp(['renaming ',fullfile(filepath,[newfilename,fileext]),' ',fullfile(filepath,[filename,fileext])]);
                end
            end
        end
    end
end
if ~nargout, CONN_x.Setup.nsubjects=value; end

