function [x,idx]=conn_get_time(V,time,slice);

if nargin<2 || isempty(time), time=1; end
if nargin<3, slice=[]; end

handle=fopen([V.fname,'c'],'rb');
if isempty(slice), 
	fseek(handle,4*(time-1),-1);
	x=fread(handle,sum(V.size.Nv),'float',4*(V.size.Nt-1));
else,
	fseek(handle,4*(sum(V.size.Nv(1:slice-1))*V.size.Nt + time-1),-1);
	x=fread(handle,V.size.Nv(slice),'float',4*(V.size.Nt-1));
	idx=rem(V.voxels(sum(V.size.Nv(1:slice-1))+(1:V.size.Nv(slice))),prod(V.matdim.dim(1:2)));
end
x=V.scale*x;
fclose(handle);


