function conn_x=conn_updatefolders(conn_x)

if nargin<1,
    global CONN_x;
    [path,name,ext]=fileparts(CONN_x.filename);if isempty(path),path=pwd;end
    if ~isfield(CONN_x,'folders'),CONN_x.folders=struct('rois',[],'data',[],'preprocessing',[],'firstlevel',[],'secondlevel',[]);end
    CONN_x.folders.rois=fullfile(fileparts(which(mfilename)),'rois');
    CONN_x.folders.data=fullfile(path,name,'data'); [ok,nill]=mkdir(path,name);[ok,nill]=mkdir(fullfile(path,name),'data');
    CONN_x.folders.preprocessing=fullfile(path,name,'results','preprocessing'); [ok,nill]=mkdir(path,name);[ok,nill]=mkdir(fullfile(path,name),'results'); [ok,nill]=mkdir(fullfile(path,name,'results'),'preprocessing');
    CONN_x.folders.firstlevel=fullfile(path,name,'results','firstlevel'); [ok,nill]=mkdir(path,name);[ok,nill]=mkdir(fullfile(path,name),'results'); [ok,nill]=mkdir(fullfile(path,name,'results'),'firstlevel');
    CONN_x.folders.secondlevel=fullfile(path,name,'results','secondlevel'); [ok,nill]=mkdir(path,name);[ok,nill]=mkdir(fullfile(path,name),'results'); [ok,nill]=mkdir(fullfile(path,name,'results'),'secondlevel');
    if ~isfield(CONN_x,'Analysis'), CONN_x.Analysis=1; end
    if ~isfield(CONN_x.Analyses(CONN_x.Analysis),'name'),CONN_x.Analyses(CONN_x.Analysis).name='ANALYSIS_01'; end
    for ianalysis=1:length(CONN_x.Analyses), if ~exist(fullfile(CONN_x.folders.firstlevel,CONN_x.Analyses(ianalysis).name),'dir'), [ok,nill]=mkdir(CONN_x.folders.firstlevel,CONN_x.Analyses(ianalysis).name); end; end;
else,
    [path,name,ext]=fileparts(conn_x.filename);if isempty(path),path=pwd;end
    if ~isfield(conn_x,'folders'),conn_x.folders=struct('rois',[],'data',[],'preprocessing',[],'firstlevel',[],'secondlevel',[]);end
    conn_x.folders.rois=fullfile(fileparts(which(mfilename)),'rois');
    conn_x.folders.data=fullfile(path,name,'data'); [ok,nill]=mkdir(path,name);[ok,nill]=mkdir(fullfile(path,name),'data');
    conn_x.folders.preprocessing=fullfile(path,name,'results','preprocessing'); [ok,nill]=mkdir(path,name);[ok,nill]=mkdir(fullfile(path,name),'results'); [ok,nill]=mkdir(fullfile(path,name,'results'),'preprocessing');
    conn_x.folders.firstlevel=fullfile(path,name,'results','firstlevel'); [ok,nill]=mkdir(path,name);[ok,nill]=mkdir(fullfile(path,name),'results'); [ok,nill]=mkdir(fullfile(path,name,'results'),'firstlevel');
    conn_x.folders.secondlevel=fullfile(path,name,'results','secondlevel'); [ok,nill]=mkdir(path,name);[ok,nill]=mkdir(fullfile(path,name),'results'); [ok,nill]=mkdir(fullfile(path,name,'results'),'secondlevel');
    if ~isfield(conn_x,'Analysis'), conn_x.Analysis=1; end
    if ~isfield(conn_x.Analyses(conn_x.Analysis),'name'),conn_x.Analyses(conn_x.Analysis).name='ANALYSIS_01'; end
    for ianalysis=1:length(conn_x.Analyses), if ~exist(fullfile(conn_x.folders.firstlevel,conn_x.Analyses(ianalysis).name),'dir'), [ok,nill]=mkdir(conn_x.folders.firstlevel,conn_x.Analyses(ianalysis).name); end; end;
end
