function conn_write_slice(V,x,slice,time0);

if nargin<4, time0=0; end
if isempty(x), return; end
if time0+size(x,1)>V.size.Nt || size(x,2)~=V.size.Nv(slice), error('mismatch dimensions'); end;
handle=fopen([V.fname,'c'],'r+b');
ok=fseek(handle,4*(sum(V.size.Nv(1:slice-1))*V.size.Nt+time0),-1);
if ok<0 error('error while writing to file'); end 
if size(x,1)~=V.size.Nt,
    for n1=1:size(x,2), fwrite(handle,x(:,n1),'float'); fseek(handle,4*(V.size.Nt-size(x,1)),0); end
else,
    fwrite(handle,x(:),'float');
end
fclose(handle);
